-- HitList! not that this game has many item interactions lol
-- by GenericHeroGuy
-- icons by Spee (thank you!)

local cv_enabled = CV_RegisterVar({
	name = "hitlist",
	defaultvalue = "On",
	possiblevalue = CV_OnOff,
--	description = "Show players getting hit." -- the punctuation wars continue
})

rawset(_G, "cv_hl", cv_enabled)

local cv_colorize = CV_RegisterVar({
	name = "hl_colorize",
	defaultvalue = "On",
	possiblevalue = CV_OnOff,
})

local cv_combos = CV_RegisterVar({
	name = "hl_combos",
	defaultvalue = "On",
	possiblevalue = CV_OnOff,
})

local cv_background = CV_RegisterVar({
	name = "hl_background",
	defaultvalue = "Off",
	possiblevalue = {
		Off = 0,
		On = 1,
		Translucent = 2,
	},
})

local cv_icons = CV_RegisterVar({
	name = "hl_playericons",
	defaultvalue = "Off",
	possiblevalue = CV_OnOff,
})

local cv_charlimit = CV_RegisterVar({
	name = "hl_charlimit",
	defaultvalue = 21, -- MAXPLAYERNAME is 21, so does nothing by default
	possiblevalue = {MIN = 4, MAX = 21}, -- 4 min - reserve 3 symbols for the '...'
})

local cv_longnames = CV_RegisterVar({
	name = "hl_longnames",
	defaultvalue = "Cut",
	possiblevalue = {
		Full = 0,
		Small = 1,
		Cut = 2,
	}
})

local cv_selfhits = CV_RegisterVar({
	name = "hl_selfhits",
	defaultvalue = "Multihit",
	possiblevalue = {
		Multihit = 0,
		Split = 1,
	},
})

local highlightcolor_t = {
	White = SKINCOLOR_WHITE,
}

-- No sglua -> no color translations -> only fallback color available (because i don't want to copy all the skincolor translation tables aaa)
if SG_CVSkinColors then
	for k, v in pairs(SG_CVSkinColors) do
		if v == 0 then continue end -- Skip None
		highlightcolor_t[k] = v
	end
	
	-- This is instead of None
	highlightcolor_t["Skincolor"] = 0
end

local cv_highlight = CV_RegisterVar({
	name = "hl_highlight",
	defaultvalue = "White",
	possiblevalue = highlightcolor_t,
})

local hitlist = {}
local timetolive = TICRATE*4
local check = {}

-- Hack to get skins from spectators
local function GetSkin(p)
	if not p then return end

	local oldspec = p.spectator
	local skin
	p.spectator = false
	skin = p.mo.skin
	p.spectator = oldspec
	return skin
end

local function AddHit(hit)
	if not cv_enabled.value then return end

	if cv_combos.value and hit.source then
		for _, hit2 in ipairs(hitlist) do
			if hit.source == hit2.source and hit.icon == hit2.icon then
				-- check for combos
				-- "WHY ARE YOU USING THE ICON!?"
				-- i mean, it effectively doubles as a "hit type"
				-- ...you ARE giving unique icons to everything, right? :)
				if hit2.targets[hit.target] then
					hit2.targets[hit.target] = $ + 1
					hit2.timestamp = leveltime
					hit2.timetodie = leveltime + timetolive
					return
				-- check for multihits
				elseif (cv_selfhits.value == 0) or (hit.target ~= hit.source) then
					-- deaths must occur on the same tic to count
					if not (hit.death and hit2.timestamp ~= leveltime) then
						hit2.targets[hit.target] = 1
						table.insert(hit2.targetorder, hit.target)
						table.insert(hit2.targetskins, GetSkin(hit.target))
						hit2.timestamp = leveltime
						hit2.timetodie = leveltime + timetolive
						return
					end
				end
			end
		end
	end

	-- no combo
	hit.targets = { [hit.target] = 1 }
	hit.targetorder = { [0] = hit.target }
	hit.targetskins = { [0] = GetSkin(hit.target) }
	hit.sourceskin = GetSkin(hit.source)
	hit.timestamp = leveltime
	hit.timetodie = leveltime + timetolive
	table.insert(hitlist, hit)
end

rawset(_G, "HL_AddHit", AddHit)

local simple = {
	[MT_SSMINE_SHIELD] = "HL_SSMINE",
	[MT_ORBINAUT] = "HL_ORBI",
	[MT_ORBINAUT_SHIELD] = "HL_ORBI",
	[MT_JAWZ] = "HL_JAWZ",
	[MT_JAWZ_DUD] = "HL_JAWZ",
	[MT_JAWZ_SHIELD] = "HL_JAWZ",
	[MT_BANANA] = "HL_BANAN",
	[MT_BANANA_SHIELD] = "HL_BANAN",
	[MT_BALLHOG] = "HL_BHOG",
	[MT_SPB] = "HL_SPB",
}

addHook("PlayerSpin", function(player, inflictor, source)
	if not (inflictor and source and source.player) then return end

	local icon
	local flash

	if inflictor.type == MT_PLAYER then
		local iplayer = inflictor.player

		if iplayer.kartstuff[k_invincibilitytimer] > 0 then
			icon = "HL_INVNC"
		--elseif iplayer.kartstuff[k_pogospring] then
		--	icon = "HL_STOMP"
		elseif iplayer.kartstuff[k_sneakertimer] > 0 then
			icon = "HL_SNKR"
		elseif iplayer.kartstuff[k_curshield] == 1 then
			icon = "HL_LSHLD"
		else
			-- I've tried every single item and still dunno what still causes to print tht
			--print("uhhh what kinda player attack is this")
			return
		end
	elseif inflictor.type == MT_SPBEXPLOSION then
		icon = (inflictor.extravalue1 == 0) and "HL_EGG" or "HL_SPB"
		if (inflictor.extravalue1 == 0) then
			flash = true
		end
	else
		icon = simple[inflictor.type]
	end

	if not icon then return end

	if inflictor.type == MT_BANANA and inflictor.health > 1 then -- banan snipe
		flash = true
	end

	local hit = {
		target = player,
		inflictor = inflictor,
		source = source.player,
		icon = icon,
		flash = flash,
	}

	AddHit(hit)
end)

addHook("PlayerExplode", function(player, inflictor, source)
	if not (inflictor and source and source.player) then return end

	local icon

	if inflictor.type == MT_SPBEXPLOSION then
		icon = (inflictor.extravalue1 == 0) and "HL_EGG" or "HL_SPB"
	else
		icon = simple[inflictor.type]
	end

	if not icon then return end

	local hit = {
		target = player,
		inflictor = inflictor,
		source = source.player,
		icon = icon,
		flash = true,
	}

	AddHit(hit)
end)

addHook("PlayerSquish", function(player, inflictor, source)
	if not (inflictor and source and source.player) then return end

	local icon

	if inflictor.type == MT_PLAYER then
		icon = "HL_GROW"
	end

	if not icon then return end

	local hit = {
		target = player,
		inflictor = inflictor,
		source = source.player,
		icon = icon,
	}

	AddHit(hit)
end)

addHook("MobjDamage", function(target, inflictor, source)
	if not (target.valid and target.player) then return end -- Uuh is this possible?

	if inflictor and inflictor.type == MT_SINK then
		AddHit({
			death = true,
			target = target.player,
			inflictor = inflictor,
			source = source and source.player,
			icon = "HL_SINK",
			flash = true,
		})
	end
end, MT_PLAYER)

HL_OnHyudoroSteal(function(victim, stealer)
	AddHit({
		target = victim,
		inflictor = stealer.mo,
		source = stealer,
		icon = "HL_HYU",
		rightpad = 9,

		hyuitem = K_GetItemPatch(stealer.kartstuff[k_itemtype], true),
		hyuamount = stealer.kartstuff[k_itemamount],
		extrafunc = function(v, hit, ofs, hx, hy, vflags)
			local icon = v.cachePatch(hit.hyuitem)
			local scale = FixedDiv(8, max(8, icon.height/2))
			hx = $ + ofs.icon
			v.drawScaled((hx+3)*FRACUNIT, (hy-3)*FRACUNIT - FRACUNIT/2, scale, icon, vflags, cmap)
			if hit.hyuamount > 1 then
				-- Too lazy to create separate function, and there are only 255 items max soo
				local nums = { hit.hyuamount/100, (hit.hyuamount % 100) / 10, hit.hyuamount % 10 }
				local last_nonzero = false
				
				for _, num in ipairs(nums) do
					if num == 0 and not last_nonzero then continue end
					
					last_nonzero = true
					
					local patch = v.cachePatch(string.format("PINGN%01d", num))
					v.drawScaled((hx+12)*FRACUNIT, (hy+5)*FRACUNIT, FRACUNIT/2, patch, vflags)
					hx = hx + 2
				end
			end
		end
	})
end)

HL_OnShrinkUse(function(user)
	AddHit({
		target = user,
		inflictor = user.mo,
		source = user,
		icon = "HL_SHRNK",
	})
end)

addHook("MapChange", do hitlist = {} end)

local HEIGHT = 11
local ICONHEIGHT = 10
local ICONOFFSET = FRACUNIT/2
local V_100TRANS = V_50TRANS*2
local FONTHEIGHTS = { thin = 9, small = 4 }

-- Should i expose others? I expose those because i need it in hitfeedcompat
rawset(_G, "HL_ICONHEIGHT", ICONHEIGHT)
rawset(_G, "HL_ICONOFFSET", ICONOFFSET)

-- somebody disconnected? no problem, just replace them :^)
local function CheckValid(hit)
	if hit.source and not hit.source.valid then
		hit.source = { name = "???", skincolor = 1, valid = true }
	end
	for target, combo in pairs(hit.targets) do
		if not target.valid then
			local dummy = { name = "???", skincolor = 1, valid = true }
			hit.targets[dummy] = combo
			hit.targets[target] = nil
			for i = 0, #hit.targetorder do
				if hit.targetorder[i] == target then hit.targetorder[i] = dummy end
			end
		end
	end
end

local function CutName(name)
	if cv_longnames.value ~= 2 then return name end

	if #name <= cv_charlimit.value then return name end
	
	return name:sub(1, cv_charlimit.value-3).."\x80..."
end

local function GetFont(v, name, vflags)
	local font = "thin"
	
	if name:len() > cv_charlimit.value then -- too long
		if cv_longnames.value == 2 then -- Cut
			name = CutName(name)
		elseif cv_longnames.value == 1 then -- Make smol
			font = "small"
		end
	end

	local width = v.stringWidth(name, vflags, font)
	
	return font, width, name
end

-- Minimap icon
local PLAYERICONSIZE = 12

local function GetOffsets(v, hit, vflags)
	local ox = 0
	local ofs = {}

	ofs.left = ox
	if hit.source and not hit.targets[hit.source] then
		if cv_icons.value then
			ofs.sourceiconx = ox
			ox = $ + HEIGHT -- Player icons are scaled to fit height
		end
		
		ofs.sourcex = ox
	
		local font, width = GetFont(v, hit.source.name, vflags)
		ofs.sourcefont = font
		ox = $ + width
	end

	ofs.icon = ox
	if hit.icon then
		local icon = v.cachePatch(hit.icon)
		local scale = FixedDiv(ICONHEIGHT, max(ICONHEIGHT, icon.height))
		ofs.icon = ox
		ox = $ + (icon.width*scale)>>FRACBITS
	end
	ox = $ + (hit.rightpad or 1)

	ofs.right = ox
	local add = 0
	ofs.targetfont = {}
	
	if cv_icons.value then
		ofs.targeticonx = ox
		ox = $ + HEIGHT -- Player icons are scaled to fit height
	end
	
	ofs.targetx = ox
	
	for target, combo in pairs(hit.targets) do
		local font, width = GetFont(v, target.name, vflags)
		ofs.targetfont[target] = font
		add = max($, width + (combo > 1 and v.stringWidth("x"..combo, vflags, "thin") + 1 or 0))
	end
	ox = $ + add

	ofs.edge = ox
	return ofs
end

local function GetColorMap(v, icon)
	local cmap = v.getColormap(TC_DEFAULT, SKINCOLOR_WHITE)

	if cv_colorize.value == 0 then return cmap end

	if icon == "HL_JAWZ" then
		cmap = v.getColormap(TC_DEFAULT, SKINCOLOR_JAWZ)
	elseif icon == "HL_BANAN" then
		cmap = v.getColormap(TC_DEFAULT, SKINCOLOR_YELLOW)
	elseif icon == "HL_BHOG" then
		cmap = v.getColormap(TC_DEFAULT, SKINCOLOR_LILAC)
	elseif icon == "HL_EGG" then
		cmap = v.getColormap(TC_DEFAULT, SKINCOLOR_ROSE)
	elseif icon == "HL_LSHLD" then
		cmap = v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN)
	elseif icon == "HL_SNEAKER" then
		cmap = v.getColormap(TC_DEFAULT, SKINCOLOR_RASPBERRY)
	elseif icon == "HL_INVNC" then
		cmap = v.getColormap(TC_DEFAULT, leveltime % MAXSKINCOLORS)
	end

	return cmap
end

local function IsLocalPlayer(p)
	for i = 0, 3 do
		if displayplayers[i] and displayplayers[i] == p then
			return true
		end
	end
	
	return false
end

local function HasLocalPlayers(t)
	for i = 0, 3 do
		if displayplayers[i] and t[displayplayers[i]] then
			return true
		end
	end
	
	return false
end

-- Taken from libsg, only ones we need
local translations = {
	[SKINCOLOR_WHITE] = {120, 120, 120, 120, 0, 2, 5, 8, 9, 11, 14, 17, 20, 22, 25, 28},
	[SKINCOLOR_BLACK] = {4, 7, 11, 15, 20, 22, 24, 27, 28, 28, 28, 29, 29, 30, 30, 31},
}

local fallbacktranslations = setmetatable({}, { __index = function(self, key)
		if translations[key] then return translations[key] end
	
		return translations[SKINCOLOR_WHITE]
	end
})

hud.add(function(v, p, c)
	if c.pnum > 1 then return end -- Only draw that once

	local translations = SG_Translations or fallbacktranslations

	for i = #hitlist, 1, -1 do
		if leveltime >= hitlist[i].timetodie then
			-- "Time to die, I guess!"
			table.remove(hitlist, i)
		end
	end

	local hy = 4
	local tallest = 64
	local snap = V_SNAPTOTOP|V_SNAPTOLEFT
	
	if splitscreen then
		snap = 0
		
		local totalheight = 0
		local maxwidth = 0
		
		for _, hit in ipairs(hitlist) do
			local multiheight = -HEIGHT
			for _ in pairs(hit.targets) do multiheight = $ + HEIGHT end
			
			totalheight = $ + HEIGHT + multiheight + 3
		end
		
		hy = 100 - totalheight / 2
	end
	
	local maxhy = hy + tallest

	for i, hit in ipairs(hitlist) do
		CheckValid(hit)

		local trans = (V_10TRANS*max(v.localTransFlag()>>V_ALPHASHIFT, leveltime - hit.timetodie + 10))

		local vflags = snap|trans
		local hx = 56

		local multiheight = -HEIGHT
		for _ in pairs(hit.targets) do multiheight = $ + HEIGHT end

		local light = IsLocalPlayer(hit.source) or HasLocalPlayers(hit.targets)

		local offsets = GetOffsets(v, hit, vflags)
		offsets.multiheight = multiheight
		
		-- Centered on splitscreen
		if splitscreen then
			hx = 160 - offsets.edge/2
		end

		hy = $ + 3

		if cv_background.value then
			local hlcolor = cv_highlight.value or p.skincolor
			local cmap = translations[light and hlcolor or SKINCOLOR_BLACK]
			
			local bg = cmap[8]
			local corner = cmap[12]
			local top = cmap[8]
			local side = cmap[8]

			-- background/corner/side widths/heights
			local bw = offsets.edge
			local bh = HEIGHT + multiheight
			local cw = offsets.edge + 1
			local ch = HEIGHT + multiheight
			local sw = offsets.edge
			local sh = HEIGHT + multiheight
		
			local bgtrans = trans
			
			if cv_background.value == 2 then
				local transnum = trans>>V_ALPHASHIFT
				bgtrans = V_10TRANS*min(9, transnum + (9 - transnum) / 2)
			end

			local bgflags = snap|bgtrans
		
			-- background
			v.drawFill(hx, hy, bw, bh, bg|bgflags)

			-- top, bottom, left, right
			v.drawFill(hx, hy - 1, sw, 1, top|bgflags)
			v.drawFill(hx, hy + sh, sw, 1, top|bgflags)

			v.drawFill(hx - 1, hy, 1, sh, side|bgflags)
			v.drawFill(hx + sw, hy, 1, sh, side|bgflags)

			-- top left, top right, bottom left, bottom right
			v.drawFill(hx - 1, hy - 1, 1, 1, corner|bgflags)
			v.drawFill(hx + cw-1, hy - 1, 1, 1, corner|bgflags)
			v.drawFill(hx - 1, hy + ch, 1, 1, corner|bgflags)
			v.drawFill(hx + cw-1, hy + ch, 1, 1, corner|bgflags)
		end

		local skincolor_to_chat = SG_Color2Chat or {}

		-- source
		if hit.source and not hit.targets[hit.source] then
			local color = skincolor_to_chat[hit.source.skincolor] or ''
			local font = offsets.sourcefont
			local fofs = (HEIGHT - FONTHEIGHTS[font])/2
			
			local sourcestr = CutName(hit.source.name)
			v.drawString(hx + offsets.sourcex, hy + multiheight/2 + fofs, color..sourcestr, vflags|V_ALLOWLOWERCASE, font)
			
			if cv_icons.value and hit.sourceskin ~= nil then
				local icon = v.cachePatch(skins[hit.sourceskin].facemmap)
				local cmap = v.getColormap(hit.sourceskin, hit.source.skincolor)
				v.drawScaled((hx + offsets.sourceiconx)<<FRACBITS, (hy + multiheight/2)<<FRACBITS, ICONHEIGHT*FRACUNIT/PLAYERICONSIZE, icon, vflags, cmap)
			end
		end

		-- icon
		if hit.icon and not hit.manualdraw then
			local cmap
			local icon = v.cachePatch(hit.icon)
			local scale = FixedDiv(ICONHEIGHT, max(ICONHEIGHT, icon.height))
			if hit.flash and leveltime & 2 then
				cmap = v.getColormap(TC_BLINK, SKINCOLOR_RED)
			else
				cmap = GetColorMap(v, hit.icon)
			end
			v.drawScaled((hx + offsets.icon)*FRACUNIT, (hy+multiheight/2)*FRACUNIT + ICONOFFSET, scale, icon, vflags, cmap)
		end

		-- target(s)
		-- for target, combo in pairs(hit.targets) do
		for i = 0, #hit.targetorder do
			local target = hit.targetorder[i]
			local combo = hit.targets[target]
			local color = skincolor_to_chat[target.skincolor] or ''
			local font = offsets.targetfont[target]
			local fofs = (HEIGHT - FONTHEIGHTS[font])/2
			
			local targetstr = CutName(target.name)
			v.drawString(hx + offsets.targetx, hy+i*HEIGHT + fofs, color..targetstr, vflags|V_ALLOWLOWERCASE, font)
			if combo > 1 then
				local nameofs = v.stringWidth(targetstr, vflags, offsets.targetfont[target]) + 1
				local color = (leveltime - hit.timestamp < TICRATE/3) and leveltime & 1 and V_ORANGEMAP or V_YELLOWMAP
				v.drawString(hx + offsets.targetx + nameofs, hy+i*HEIGHT, "x"..combo, vflags|color|V_ALLOWLOWERCASE, "thin")
			end
			
			
			if cv_icons.value and hit.targetskins[i] then
				local icon = v.cachePatch(skins[hit.targetskins[i]].facemmap)
				local cmap = v.getColormap(hit.targetskins[i], target.skincolor)
				v.drawScaled((hx + offsets.targeticonx)<<FRACBITS, (hy+i*HEIGHT)<<FRACBITS, ICONHEIGHT*FRACUNIT/PLAYERICONSIZE, icon, vflags, cmap)
			end
		end

		-- extra drawing function
		if hit.extrafunc then
			hit.extrafunc(v, hit, offsets, hx, hy, vflags)
		end

		hy = $ + HEIGHT + multiheight
		
		if hy >= maxhy then return end
	end
end)
