local on_shrink_use = {}

-- Hook format: function(player_t user)
rawset(_G, "HL_OnShrinkUse", function(hook)
	table.insert(on_shrink_use, hook)
end)

addHook("ThinkFrame", function()
	for p in players.iterate
		if not p.mo then continue end
		if P_PlayerInPain(p) then continue end
		if p.deadtimer then continue end
		
		if p.hl_shrink ~= nil and p.hl_shrink > p.kartstuff[k_itemamount] and (p.pflags & PF_ATTACKDOWN) then
			for _, hook in ipairs(on_shrink_use) do
				hook(p)
			end
		end
		
		if p.kartstuff[k_itemtype] == KITEM_SHRINK then
			p.hl_shrink = p.kartstuff[k_itemamount]
		else
			p.hl_shrink = nil
		end
	end
end)

addHook("PlayerExplode", function(p)
	p.hl_shrink = nil
end)

HL_OnHyudoroSteal(function(p)
	p.hl_shrink = nil
end)